VERSION 5.00
Object = "{344E011D-7EF2-4612-9DE8-5354720F9B43}#33.0#0"; "SoundProcessor.ocx"
Begin VB.Form frmAnimation 
   Caption         =   "www.ActiveVB.de - Animationen mit dem Sndproc.Ocx"
   ClientHeight    =   6405
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6930
   LinkTopic       =   "Form1"
   ScaleHeight     =   6405
   ScaleWidth      =   6930
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame3 
      BorderStyle     =   0  'None
      Caption         =   "Frame3"
      Height          =   465
      Left            =   45
      TabIndex        =   1
      Top             =   5910
      Width           =   6855
      Begin VB.ComboBox Combo1 
         Height          =   315
         Left            =   3885
         Style           =   2  'Dropdown List
         TabIndex        =   8
         Top             =   75
         Width           =   2430
      End
      Begin prjSndProc.SndProc SndProc1 
         Height          =   255
         Left            =   6480
         TabIndex        =   7
         Top             =   90
         Width           =   285
         _ExtentX        =   503
         _ExtentY        =   450
      End
      Begin VB.CommandButton cmdCls 
         Caption         =   "Cls"
         Height          =   360
         Left            =   2985
         TabIndex        =   6
         Top             =   60
         Width           =   720
      End
      Begin VB.CommandButton cmdPause 
         Caption         =   "Pause"
         Enabled         =   0   'False
         Height          =   375
         Left            =   1425
         TabIndex        =   5
         Top             =   60
         Width           =   700
      End
      Begin VB.CommandButton cmdInit 
         Caption         =   "Init"
         Height          =   375
         Left            =   15
         TabIndex        =   4
         Top             =   60
         Width           =   700
      End
      Begin VB.CommandButton cmdStop 
         Caption         =   "Stop"
         Height          =   375
         Left            =   2130
         TabIndex        =   3
         Top             =   60
         Width           =   700
      End
      Begin VB.CommandButton cmdStart 
         Caption         =   "Start"
         Enabled         =   0   'False
         Height          =   375
         Left            =   720
         TabIndex        =   2
         Top             =   60
         Width           =   700
      End
   End
   Begin VB.PictureBox pic 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      Height          =   5835
      Left            =   45
      ScaleHeight     =   385
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   452
      TabIndex        =   0
      Top             =   30
      Width           =   6840
   End
End
Attribute VB_Name = "frmAnimation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim xoff As Long
Dim yoff As Long

Private Type PointApi

    X As Long
    Y As Long

End Type

Dim Pt() As PointApi

Private Declare Function PolyGon Lib "gdi32" Alias "Polygon" (ByVal hdc As _
                                       Long, lpPoint As _
                                       PointApi, ByVal nCount As Long) As Long
                                       
Private Declare Function PolyLine Lib "gdi32" Alias "Polyline" (ByVal hdc As _
                                       Long, lpPoint As _
                                       PointApi, ByVal nCount As Long) As Long
                                       
                                                                              





Sub Lissajous(pic As Control)

    Dim DataL() As Integer
    Dim DataR() As Integer
    Dim n As Long
    Dim i As Long
    Dim j As Long
    Dim ret As Long
    Dim A As Double
    Dim Fx As Double
    
    n = SndProc1.Samples - 1
    ret = SndProc1.WaveData(DataL(), 1) ' Linken Kanal bernehmen
    ret = SndProc1.WaveData(DataR(), 2) ' Rechten Kanal bernehmen
    
    A = 0.01 ' Faktor fr die Amplitude festlegen
    Fx = 0.5
    
    For i = 0 To n
    
        j = i + (n / 2) ' Hierdurch wird eine Phasenverschiebung erzeugt
        If j > n Then
            j = j - n
        End If
        
        ' Wir tragen den i-ten Punkt in y gegen den i+(n/2)-ten Punkt in
        ' x-Richtung auf. Wird ein reiner Sinus gespielt, so ergibt dies
        ' einen Kreis oder eine Lissajous-Figur.
        
        Pt(i).Y = yoff + A * DataL(i)
        Pt(i).X = xoff + A * DataL(j)
        'pt(i).X = xoff + A * DataR(j) ' man kann auch die Daten des rechtn
        ' Kanals fr x verwenden.
        
    Next i
   
    pic.Cls
    PolyGon pic.hdc, Pt(0), n
    pic.Refresh
    
End Sub

Sub Oscilloscope(pic As Control)

    Dim DataL() As Integer
    Dim DataR() As Integer
    Dim n As Long
    Dim i As Long
    Dim j As Long
    Dim ret As Long
    Dim A As Double
    Dim Fx As Double
    
    n = SndProc1.Samples - 1
    ret = SndProc1.WaveData(DataL(), 1) ' Linken Kanal bernehmen
    ret = SndProc1.WaveData(DataR(), 2) ' Rechten Kanal bernehmen
    
    A = 0.01 ' Faktor fr die Amplitude festlegen
    Fx = 0.4
    
    ' Einfache Darstellung wie beim Oszilloskop. Die Amplitude wird
    ' in Abhngigkeit der Zeit aufgetragen.
    For i = 0 To n
    
        Pt(i).Y = yoff + A * DataL(i)
        Pt(i).X = xoff + -(n / 2) * Fx + i * Fx
        
    Next i
    
    ' Durch eine zeitliche nderung von xoff und yoff kann man eine
    ' Bewegung erzeugen. Anstelle des .Cls knnte man ein langsames Fading
    ' der Kurve zusammen mit einer Bewegung einfhren.
   
    pic.Cls
    PolyLine pic.hdc, Pt(0), n
    pic.Refresh
    
End Sub


Sub Lissajous2(pic As Control)

    Dim DataL() As Integer
    Dim DataR() As Integer
    Dim n As Long
    Dim i As Long
    Dim j As Long
    Dim ret As Long
    Dim A As Double
    Dim R As Long
    Dim pi As Double
    Dim PhiStep As Double
    Dim Phi As Double
    
    n = SndProc1.Samples - 1
    ret = SndProc1.WaveData(DataL(), 1) ' Linken Kanal bernehmen
    ret = SndProc1.WaveData(DataR(), 2) ' Rechten Kanal bernehmen
    
    A = 0.001 ' Faktor fr die Amplitude festlegen
    
    R = 50
    'R = SndProc1.MaxAmplitudeL * 0.005  ' so kann man den Radius von der
                                        ' Lautstrke abhngig machen.
    pi = 4 * Atn(1)
    PhiStep = 2 * pi / n
'     PhiStep = 16 * pi / n            ' kann man auchmal probieren
    
    For i = 0 To n
    
        j = i + (n / 2) ' Hierdurch wird eine Phasenverschiebung erzeugt
        If j > n Then
            j = j - n
        End If
        
        Phi = PhiStep * i
        yp = R * Sin(Phi) ' Kreis berechnen
        xp = R * Cos(Phi)
        
        ' Ist die Amplitude (Laustrke) null, so wird ein Kreis dargestellt.
        ' Ist die Amplitude ungleich null, so wird das Signal auf den Kreis
        ' berlagert. Durch ndern der Parameter R und A kann man unterschieliche
        ' Figuren erzeugen. Durch eine zeitliche nderung von xoff und yoff
        ' kann man erreichen, dass sich der Kreis ber die Flche bewegt.
        
        Pt(i).Y = yoff + yp + A * DataL(i)
        Pt(i).X = xoff + xp + A * DataL(j)
         
    Next i
   
    pic.Cls
    PolyGon pic.hdc, Pt(0), n
    pic.Refresh
    
End Sub
Private Sub cmdCls_Click()
    pic.Cls
End Sub


Private Sub cmdInit_Click()

    SndProc1.SPS = 44100
    SndProc1.Samples = 1024
    SndProc1.Buffers = 1    ' Bis 10 Puffer sind sinnvoll.
    SndProc1.LoopMethod = 1 ' Subclassing um WM_DONE abzufangen
    SndProc1.Channels = 2   ' Stereo
    SndProc1.Analysis = 1   ' Es wird nur die maximale Amplitude bestimmt
    SndProc1.Init           ' Bereitschaft zur Aufnahme und Subclassing initialisieren.
    
    ReDim Pt(SndProc1.Samples - 1)
    
    cmdPause.Enabled = True
    cmdStart.Enabled = True
    
End Sub


Private Sub cmdPause_Click()
    Call SndProc1.Pause
    cmdStart.Enabled = True
End Sub

Private Sub cmdStart_Click()
    
    Call SndProc1.Start
    cmdStart.Enabled = 0
    cmdPause.Enabled = True
    
End Sub


Private Sub cmdStop_Click()

    SndProc1.Reset
    cmdInit.Enabled = True
    cmdStart.Enabled = 0
    cmdPause.Enabled = 0
    
End Sub

Private Sub Form_Load()
    
    Combo1.AddItem "Oscilloscope"
    Combo1.AddItem "Lissajous"
    Combo1.AddItem "Lissajous plus Circle"
    Combo1.ListIndex = 0
    
    pic.Forecolor = vbYellow
    ReDim Pt(1)
    
End Sub


Private Sub Form_Resize()

    pic.Width = Me.ScaleWidth - 2 * pic.Left
    pic.Height = Me.ScaleHeight - 2 * pic.Top - Frame3.Height
    'Picture1.Move pic.Left, pic.Top, pic.Width, pic.Height
    Frame3.Top = pic.Top + pic.Height
    
    xoff = pic.ScaleWidth / 2
    yoff = pic.ScaleHeight / 2
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
    Call cmdStop_Click
End Sub


Private Sub SndProc1_Complete(ByVal BlockIndex As Long, ByVal BufferIndex As Long, ByVal dt As Double)

    Select Case Combo1.ListIndex
    Case 0
        Call Oscilloscope(pic)
    Case 1
        Call Lissajous(pic)
    Case 2
        Call Lissajous2(pic)
    End Select
End Sub


